# Tcl Windows API (TWAPI) 4.1

This is the release version of TWAPI 4.1.

  * Project home page is at http://twapi.sourceforge.net
  * V4.1 documentation is at http://twapi.sourceforge.net/v4.1

## Supported platforms

TWAPI 4.1 requires

  * Windows XP (32-bit only) or later (32- or 64- bit)
  * Tcl 8.5 or 8.6 (32- or 64-bit)

## Changes since 4.0

Major changes in this release are support for writing COM servers
and other COM enhancements, STARTTLS support for TLS sockets,
and additional functionality in the security, services,
device management and console modules.

For a complete list, including INCOMPATIBLE CHANGES, see 
http://twapi.sourceforge.net/v4.1/versionhistory.html

## Distributions

TWAPI is distributed in multiple formats.
See http://twapi.sourceforge.net/v4.1/installation.html for the details
and the pros and cons of each format.

## TWAPI Summary

The Tcl Windows API (TWAPI) extension provides
access to over 600 functions in the Windows API
from within the Tcl scripting language.

Functions in the following areas are implemented:

  * System functions including OS and CPU information,
    shutdown and message formatting
  * User and group management
  * COM client and server support
  * Security and resource access control
  * Window management
  * User input: generate key/mouse input and hotkeys
  * Basic sound playback functions
  * Windows services
  * Windows event log access
  * Windows event tracing
  * Process and thread management
  * Directory change monitoring
  * Lan Manager and file and print shares
  * Drive information, file system types etc.
  * Network configuration and statistics
  * Network connection monitoring and control
  * Named pipes
  * Clipboard access
  * Taskbar icons and notifications
  * Console mode functions
  * Window stations and desktops
  * Internationalization
  * Task scheduling
  * Shell functions 
  * Windows Installer
  * Synchronization
  * Power management
  * Device I/O and management
  * Crypto API and certificates
  * SSL/TLS
  * Windows Performance Counters
